/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.workflow.action;

import java.util.Date;

import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.kintai.common.action.MosPWorkflowAction;
import jp.mosp.workflow.dto.AmUnitDto;
import jp.mosp.workflow.vo.ApprovalUnitCardVo;

/**
 * @author yoshida
 *
 */
public class ApprovalUnitCardAction extends MosPWorkflowAction {
	
	// コマンド
	private static final String	CMD_UNIT_CARD_SHOW		= "S2815";	// 表示(追加)
	private static final String	CMD_UNIT_CARD_SELECT	= "S2816";	// 表示(選択)
	private static final String	CMD_UNIT_CARD_INSERT	= "S2817";	// 登録
	private static final String	CMD_UNIT_CARD_UPDATE	= "S2818";	// 更新
																	
	
	/**
	 * コンストラクタ
	 */
	public ApprovalUnitCardAction() {
		super();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得及び設定
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_UNIT_CARD_SHOW)) {
			show();
		} else if (cmd.equals(CMD_UNIT_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			select();
		} else if (cmd.equals(CMD_UNIT_CARD_INSERT)) {
			// 新規登録
			insert();
		} else if (cmd.equals(CMD_UNIT_CARD_UPDATE)) {
			// 更新
			update();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new ApprovalUnitCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// プルダウンのセット
		ApprovalUnitCardVo vo = (ApprovalUnitCardVo)getVo();
		// MANAGER権限所有社員コード一覧
		vo.aryPltManager = part().human().getBasisArrayForApproval();
		// 年
		vo.aryPltYear = StringUtil.getYearArray(MospUtility.getYear(DateUtil.getSystemDate()), 10, 5);
		// 月
		vo.aryPltMonth = StringUtil.getMonthArray();
		/*
		 * 		2008/11/06	m.yoshida	修正
		 */
		// 日
		vo.aryPltDay = StringUtil.getDayArray();
		vo.setParams(request);
	}
	
	@Override
	protected void show() throws Exception {
		ApprovalUnitCardVo vo = (ApprovalUnitCardVo)getVo();
		vo.setDefaultValues();
		Date todayDate = DateUtil.getSystemDate();
		vo.setPltStartYear(String.valueOf(MospUtility.getYear(getStartDate(todayDate))));
		vo.setPltStartMonth(String.valueOf(MospUtility.getMonth(getStartDate(todayDate))));
		/*						
		 *  	2008/11/04	m.yoshida	修正
		 */
		vo.setPltStartDay(String.valueOf(MospUtility.getDay(getStartDate(todayDate))));
		// モード設定
		setMode();
	}
	
	@Override
	protected void select() throws Exception {
		ApprovalUnitCardVo vo = (ApprovalUnitCardVo)getVo();
		// データの取得
		AmUnitDto dto = unitDao().findForKey(key1, key2);
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		vo.setMode(ApprovalUnitCardVo.MODE_UPDATE);
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void insert() throws Exception {
		ApprovalUnitCardVo vo = (ApprovalUnitCardVo)getVo();
		// パラメータの妥当性確認
		vo.validate();
		// 存在チェック
		chkDuplicate(unitDao().findForKey(vo.getTxtUnitCode(), DateUtil.convStringDateFormattedByHyphen(
		/*						
		 *  	2008/11/04	m.yoshida	修正
		 */
		vo.getPltStartYear(), vo.getPltStartMonth(), vo.getPltStartDay())));
		// DTOの準備
		AmUnitDto dto = new AmUnitDto();
		vo.setPltDelete(String.valueOf(MospConst.DELETE_FLAG_OFF));
		vo.setDtoFields(dto);
		// データの挿入
		unitDao().insert(dto);
		// DTOの再取得
		dto = unitDao().findForKey(dto.getUnitCode(), dto.getStartDate());
		// コミット
		commit();
		// モード設定
		vo.setMode(ApprovalUnitCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void update() throws Exception {
		// DTOの取得
		AmUnitDto dto = (AmUnitDto)getSessionDto();
		ApprovalUnitCardVo vo = (ApprovalUnitCardVo)getVo();
		// コード取得
		vo.setTxtUnitCode(dto.getUnitCode());
		// 年月日取得
		vo.setPltStartYear(String.valueOf(MospUtility.getYear(dto.getStartDate())));
		vo.setPltStartMonth(String.valueOf(MospUtility.getMonth(dto.getStartDate())));
		/*						
		 *  	2008/11/04	m.yoshida	修正
		 */
		vo.setPltStartDay(String.valueOf(MospUtility.getDay(dto.getStartDate())));
		// パラメータの妥当性確認
		vo.validate();
		// 排他確認
		chkExclusive(dto, unitDao().findForUpdate(vo.getTxtUnitCode(), DateUtil.convStringDateFormattedByHyphen(
		/*						
		 *  	2008/11/04	m.yoshida	修正
		 */
		vo.getPltStartYear(), vo.getPltStartMonth(), vo.getPltStartDay())));
		// DTOの準備
		vo.setDtoFields(dto);
		// データの更新
		unitDao().update(dto);
		// DTOの再取得
		AmUnitDto retDto = unitDao().findForKey(dto.getUnitCode(), dto.getStartDate());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		vo.setMode(ApprovalUnitCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_UPDATE, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	/**
	 * モード設定
	 */
	private void setMode() {
		ApprovalUnitCardVo vo = (ApprovalUnitCardVo)getVo();
		// モード設定
		if (vo.aryPltManager.length == 0) {
			vo.setMode(ApprovalUnitCardVo.MODE_IMPOSSIBLE);
		} else {
			vo.setMode(ApprovalUnitCardVo.MODE_INSERT);
		}
	}
	
}
